# -*- coding: utf-8 -*-
"""june16.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1zthLgRDX2LF4NOK7QRH-nXR7SpPUfs9E

# Question 1
**Program for Greedy Algorithm to find Minimum number of Coins**

Given a value V, if we want to make change for V Rs, and we have infinite supply of each of the
denominations in Indian
currency, i.e., we have infinite supply of { 1, 2, 5, 10, 20, 50, 100, 500, 1000} valued coins/notes, what is the
minimum
number of coins and/or notes needed to make the change?

Examples:

Input: V = 70
Output: 2
(We need a 50 Rs note and a 20 Rs note)

Input: V = 121
Output: 3
(We need a 100 Rs note, a 20 Rs note and a
1 Rs coin)
"""

# Python 3 program to find minimum 
# number of denominations 

def findMin(V): 
	
	# All denominations of Indian Currency 
	deno = [1, 2, 5, 10, 20, 50, 
			100, 500, 1000] 
	n = len(deno) 
	
	# Initialize Result 
	ans = [] 

	# Traverse through all denomination 
	i = n - 1
	while(i >= 0): 
		
		# Find denominations 
		while (V >= deno[i]): 
			V -= deno[i] 
			ans.append(deno[i]) 

		i -= 1

	# Print result 
	for i in range(len(ans)): 
		print(ans[i], end = " ") 

# Driver Code 
if __name__ == '__main__': 
	n = 93
	print("Following is minimal number", 
		"of change for", n, ": ", end = "") 
	findMin(n)

"""# Question 2
**Implement fractional knapsack problem using greedy approach**

Input: items[] = [ [60, 10], [100, 20], [120, 30] ]

Knapsack Capacity(capacity) = 50

Output: Maximum possible value = 240

Explanation: By taking full items of 10 kg, 20 kg and 2/3rd of last item of 30 kg. Total value = 60 + 100 +
120*2/3 = 240
"""

# Python3 program to solve fractional 
# Knapsack Problem 
class ItemValue: 
	
	"""Item Value DataClass"""
	def __init__(self, wt, val, ind): 
		self.wt = wt 
		self.val = val 
		self.ind = ind 
		self.cost = val // wt 

	def __lt__(self, other): 
		return self.cost < other.cost 

# Greedy Approach 
class FractionalKnapSack: 
	
	"""Time Complexity O(n log n)"""
	@staticmethod
	def getMaxValue(wt, val, capacity): 
		
		"""function to get maximum value """
		iVal = [] 
		for i in range(len(wt)): 
			iVal.append(ItemValue(wt[i], val[i], i)) 

		# sorting items by value 
		iVal.sort(reverse = True) 

		totalValue = 0
		for i in iVal: 
			curWt = int(i.wt) 
			curVal = int(i.val) 
			if capacity - curWt >= 0: 
				capacity -= curWt 
				totalValue += curVal 
			else: 
				fraction = capacity / curWt 
				totalValue += curVal * fraction 
				capacity = int(capacity - (curWt * fraction)) 
				break
		return totalValue 

# Driver Code 
if __name__ == "__main__": 
	wt = [10, 40, 20, 30] 
	val = [60, 40, 100, 120] 
	capacity = 50

	maxValue = FractionalKnapSack.getMaxValue(wt, val, capacity) 
	print("Maximum value in Knapsack =", maxValue)

"""# Question 3
Given n items of different weights and bins each of capacity c, assign each item to a bin such that number of total used bins is minimized. It may be assumed that all items have weights smaller than bin capacity.

Input:  wieght[]       = {4, 8, 1, 4, 2, 1}

Bin Capacity c = 10

Output: 2
We need minimum 2 bins to accommodate all items
First bin contains {4, 4, 2} and second bin {8, 2}
"""

# Python3 implementation for above approach 
def nextfit(weight, c): 
	res = 0
	rem = c 
	for _ in range(len(weight)): 
		if rem >= weight[_]: 
			rem = rem - weight[_] 
		else: 
			res += 1
			rem = c - weight[_] 
	return res 

# Driver Code 
weight = [2, 5, 4, 7, 1, 3, 8] 
c = 10

print("Number of bins required in Next Fit :", 
						nextfit(weight, c))

# Python3 program to find number of bins required using 
# First Fit algorithm. 

# Returns number of bins required using first fit 
# online algorithm 
def firstFit(weight, n, c): 
	
	# Initialize result (Count of bins) 
	res = 0; 

	# Create an array to store remaining space in bins 
	# there can be at most n bins 
	bin_rem = [0]*n; 

	# Place items one by one 
	for i in range(n): 
		
		# Find the first bin that can accommodate 
		# weight[i] 
		j = 0; 
		
		# Initialize minimum space left and index 
		# of best bin 
		min = c + 1; 
		bi = 0; 

		for j in range(res): 
			if (bin_rem[j] >= weight[i] and bin_rem[j] - weight[i] < min): 
				bi = j; 
				min = bin_rem[j] - weight[i]; 
			
		# If no bin could accommodate weight[i], 
		# create a new bin 
		if (min == c + 1): 
			bin_rem[res] = c - weight[i]; 
			res += 1; 
		else: # Assign the item to best bin 
			bin_rem[bi] -= weight[i]; 
	return res; 

# Driver code 
if __name__ == '__main__': 
	weight = [ 2, 5, 4, 7, 1, 3, 8 ]; 
	c = 10; 
	n = len(weight); 
	print("Number of bins required in First Fit : ", firstFit(weight, n, c));